Apply by doing:
	cd /usr/XF4     # Assuming XF4 is in /usr/XF4
	patch -p0 < 014_xorg.patch

And then rebuild and install X:
	make build

Index: xc/programs/Xserver/fb/fbtrap.c
===================================================================
RCS file: /cvs/XF4/xc/programs/Xserver/fb/fbtrap.c,v
retrieving revision 1.3
diff -u -r1.3 fbtrap.c
--- xc/programs/Xserver/fb/fbtrap.c	8 Jan 2006 21:18:16 -0000	1.3
+++ xc/programs/Xserver/fb/fbtrap.c	9 May 2007 17:36:48 -0000
@@ -115,6 +115,9 @@
     RenderEdge	l, r;
     xFixed	t, b;
     
+    if (!xTrapezoidValid (trap))
+	return;
+
     fbGetDrawable (pPicture->pDrawable, buf, stride, bpp, pxoff, pyoff);
 
     width = pPicture->pDrawable->width;
Index: xc/programs/Xserver/render/renderedge.c
===================================================================
RCS file: /cvs/XF4/xc/programs/Xserver/render/renderedge.c,v
retrieving revision 1.2
diff -u -r1.2 renderedge.c
--- xc/programs/Xserver/render/renderedge.c	8 Jan 2006 21:18:25 -0000	1.2
+++ xc/programs/Xserver/render/renderedge.c	9 May 2007 17:36:51 -0000
@@ -143,6 +143,7 @@
     dx = x_bot - x_top;
     dy = y_bot - y_top;
     e->dy = dy;
+    e->dx = 0;
     if (dy)
     {
 	if (dx >= 0)
